int depth = 1000;
int maxAcc = 5;
int maxVel = 5;

class Agent {
  boolean on = true;
  PVector position; // how should starting position be determined?
  PVector velocity; 
  PVector acceleration;
  PVector drag; 
  float size;  // "mass" of the particles
  color c;
  String letter;
  int trial_index;
  
  float[][] features;
  // each feature will be a parameter that drives phenotype of the agent
  // each sensor (containing 24 feature values) is ?????
  
  Agent(String letter, int trial_index) {
    features = new float[NUM_SENSORS][NUM_FEATURES];
    size = 5; // what should size be mapped to?? 
    this.letter = letter;
    this.trial_index = trial_index;
    
    c = color( int(letter.charAt(0) - 65)*10,  // map hue to which letter it is
               int(letter.charAt(0) - 65)*10,
               //map(trial_index, 1, 40, 10, 255), // map trial number to how saturated the color is
               255); // brightness value = max
  }
  
  void setupMotionParameters() {
    position = new PVector( map(features[0][feature_for_viz], -2, 2, 0, width), 
                            map(features[1][feature_for_viz], -2, 2, 0, height), 
                            map(features[2][feature_for_viz], -2, 2, 0, depth/2) );  
    // x = selected feature from sensor 1, mapped to screen
    // y = selected feature from sensor 2, mapped to screen
    // z = selected feature from sensor 3, mapped to screen
    
    size = map(features[3][feature_for_viz], -2, 2, 1, 20); 
    // selected feature from sensor 4 determines mass of particle
    
    
    velocity = new PVector(  map(features[0][feature_for_viz], -2, 2, -maxVel, maxVel), 
                             map(features[1][feature_for_viz], -2, 2, -maxVel, maxVel), 
                             map(features[2][feature_for_viz], -2, 2, -maxVel, maxVel)  );
    // x = selected feature from sensor 1
    // y = selected feature from sensor 2
    // z = selected feature from sensor 3
    
    // WHAT SHOULD SENSOR 4 FEATURE 2 BE?

    acceleration = new PVector( map(features[0][feature_for_viz], -2, 2, -maxAcc, maxAcc),
                                map(features[1][feature_for_viz], -2, 2, -maxAcc, maxAcc), 
                                map(features[2][feature_for_viz], -2, 2, -maxAcc, maxAcc) );
                                
    // x = Spectral Centroid (center frequency value across signal after computing Discrete Fourier Transform), from sensor 1
    // y = Spectral Centroid, sensor 2
    // z = Spectral Centroid, sensor 3
    
    // what about sensor 4???
    
    
    
    drag = new PVector( 0, 0, 0 ); 
    // figure out what kind of friction you want to implement in the system
  }
  
  void printGenotype() {
    println("Agent: " + letter + " Trial: " + trial_index); 
    for (int i = 0; i < NUM_SENSORS; i++) {
      println("sensor number " + (i+1));
      for (int j = 0; j < NUM_FEATURES; j++) {
        print(features[i][j] + " ");
      }
      println();
    }
    println("-----------------------------");
  }
  
  void display() {
    if (on) {
      pushMatrix();
      noStroke();
      translate(position.x, position.y, position.z);
      fill(c); 
      rotateX(cam.getRotations()[0]); //rotate towards the camera angle in X direction
      rotateY(cam.getRotations()[1]); //rotate towards the camera angle in Y direction
      rotateZ(cam.getRotations()[2]); //rotate towards the camera angle in Z direction
      ellipse(0, 0, size, size);
      popMatrix();
    }
  }
  
  void calculateForces() {
    acceleration = new PVector( map(features[0][feature_for_viz+2], -2, 2, -maxAcc, maxAcc),
                                map(features[1][feature_for_viz+2], -2, 2, -maxAcc, maxAcc), 
                                map(features[2][feature_for_viz+2], -2, 2, -maxAcc, maxAcc) );
  }
  
  void move() {
    // TO DO: add drag into this
    if (velocity.mag() != 0) {
      position.x += velocity.x + (acceleration.x * size);
      position.y += velocity.y + (acceleration.y * size);
      position.z += velocity.z + (acceleration.z * size);
    
      acceleration.mult(0);
    }
  }
  
  void handleBoundaries() { // change direction if at the edge of the boundary
    if (position.x > width*2 || position.x < 0) {
      velocity.x = 0; 
    }
    
    if (position.y > height*2 || position.y < 0) {
      velocity.y = 0;  
    }
    
    if (position.z > depth*2 || position.z < 0) {
      velocity.z = 0; 
    }
  }
  
}
